Index: trunk/src/world_entities/projectiles/spike.cc
===================================================================
--- trunk/src/world_entities/projectiles/spike.cc	(revision 10697)
+++ trunk/src/world_entities/projectiles/spike.cc	(revision 10698)
@@ -111,5 +111,5 @@
 
   this->toList(OM_NULL);
-  this->removeNode();
+//   this->removeNode();
   Spike::fastFactory->kill(this);
 }
Index: trunk/src/world_entities/projectiles/spike_ball.cc
===================================================================
--- trunk/src/world_entities/projectiles/spike_ball.cc	(revision 10697)
+++ trunk/src/world_entities/projectiles/spike_ball.cc	(revision 10698)
@@ -149,5 +149,5 @@
 
   this->toList(OM_NULL);
-  this->removeNode();
+//   this->removeNode();
   SpikeBall::fastFactory->kill(this);
 }
Index: trunk/src/world_entities/projectiles/swarm_projectile.cc
===================================================================
--- trunk/src/world_entities/projectiles/swarm_projectile.cc	(revision 10697)
+++ trunk/src/world_entities/projectiles/swarm_projectile.cc	(revision 10698)
@@ -134,5 +134,5 @@
 
   this->toList(OM_DEAD);
-  this->removeNode();
+//   this->removeNode();
   SwarmProjectile::fastFactory->kill(this);
 }
@@ -200,9 +200,6 @@
     this->deactivate();
 
-
-
 /** old  guiding function*/
-
-  float projectileVelocity = this->getVelocity().len();
+  static float projectileVelocity = this->getVelocity().len();
   if (target != NULL){
     Vector estTargetDir = (this->target->getAbsCoor() - this->getAbsCoor()).getNormalized();
@@ -225,9 +222,5 @@
 
   this->angle += this->rotationSpeed * time;
-
-  while (this->angle > 360)
-  {
-    this->angle -= 360;
-  }
+  while (this->angle > 360) { this->angle -= 360; }
 
   this->lastDir = this->curDir;
@@ -240,5 +233,5 @@
     PRINTF(0)("Target was hit by Swarm Missile!\n");
   }
-  else if( this->target == NULL)
+  if( this->target == NULL)
     this->deactivate();
 }
Index: trunk/src/world_entities/space_ships/space_ship.cc
===================================================================
--- trunk/src/world_entities/space_ships/space_ship.cc	(revision 10697)
+++ trunk/src/world_entities/space_ships/space_ship.cc	(revision 10698)
@@ -22,8 +22,13 @@
 #include "util/loading/resource_manager.h"
 
+#include "world_entities/weapons/weapon_manager.h"
+
 #include "weapons/test_gun.h"
 #include "weapons/light_blaster.h"
 #include "weapons/medium_blaster.h"
 #include "weapons/heavy_blaster.h"
+#include "weapons/rf_cannon.h"
+#include "weapons/nadion_laser.h"
+#include "weapons/disruptor.h"
 #include "weapons/swarm_launcher.h"
 #include "weapons/spike_thrower.h"
@@ -61,4 +66,6 @@
 #include "tools/cameraman.h"
 
+#include "tools/mount_point.h"
+#include "weapons/weapon_slot.h"
 
 #include "util/loading/load_param.h"
@@ -66,9 +73,5 @@
 
 #include "track/track.h"
-
-
-// #include "lib/gui/gl_gui/glgui_bar.h"
-// #include "lib/gui/gl_gui/glgui_pushbutton.h"
-
+#include "track/action_box.h"
 
 
@@ -156,101 +159,73 @@
   //weapons:
 
-  Weapon* wpRight1 = new LightBlaster ();
-  wpRight1->setName( "LightBlaster");
-  Weapon* wpLeft1 = new LightBlaster ();
-  wpLeft1->setName( "LightBlaster");
-
-  Weapon* wpRight2 = new MediumBlaster ();
-  wpRight2->setName( "MediumBlaster");
-  Weapon* wpLeft2 = new MediumBlaster ();
-  wpLeft2->setName( "MediumBlaster");
-
-  Weapon* wpRight3 = new HeavyBlaster (1);
-  wpRight3->setName( "HeavyBlaster");
-  Weapon* wpLeft3 = new HeavyBlaster (0);
-  wpLeft3->setName( "HeavyBlaster");
-
-  Weapon* cannon = new SwarmLauncher();
-  cannon->setName( "SwarmLauncher");
-/*
-  Weapon* spike = new SpikeThrower();
-  spike->setName( "SpikeThrower" );
-
-
-  Weapon* acid0 = new AcidLauncher();
-  acid0->setName( "AcidSplasher" );
-
-  Weapon* acid1 = new AcidLauncher();
-  acid1->setName( "AcidSplasher" );*/
-
-
-  this->weaponMan.addWeapon( wpLeft1, 0, 0);
-  this->weaponMan.addWeapon( wpRight1, 0, 1);
-
-  this->weaponMan.addWeapon( wpLeft2, 1, 2);
-  this->weaponMan.addWeapon( wpRight2, 1, 3);
-
-  this->weaponMan.addWeapon( wpLeft3, 2, 4);
-  this->weaponMan.addWeapon( wpRight3, 2, 5);
-
-  this->weaponMan.addWeapon( wpLeft1, 3, 0);
-  this->weaponMan.addWeapon( wpRight1, 3, 1);
-
-  this->weaponMan.addWeapon( wpLeft2, 3, 2);
-  this->weaponMan.addWeapon( wpRight2, 3, 3);
-
-  this->weaponMan.addWeapon( wpLeft3, 3, 4);
-  this->weaponMan.addWeapon( wpRight3, 3, 5);
-
-
-//   this->weaponMan.addWeapon( acid0, 3, 0);
-//   this->weaponMan.addWeapon( acid1, 3, 1);
-
-
-  this->secWeaponMan.addWeapon( cannon, 0, 2);
-//   this->secWeaponMan.addWeapon( spike, 1, 3);
-//   this->secWeaponMan.addWeapon( acid0, 2, 2);
-//   this->secWeaponMan.addWeapon( acid1, 2, 3);
-
-
-  this->weaponMan.changeWeaponConfig(3);
+  this->weaponMan.setParentEntity( this);
+  this->secWeaponMan.setParentEntity( this);
+
+  this->weaponMan.setSlotCount(8);
+  this->secWeaponMan.setSlotCount(6);
+
+  this->weaponMan.createWeaponSlot(0, 3.270, 1.028, .155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(1, 3.270, 1.028, -.155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(2, 4.385, .063, .876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(3, 4.385, -.063, -.876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(4, 1.635, -.612, 2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(5, 1.536, -.612, -2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(6, 1.536, -.612, 3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(7, 1.536, -.612, -3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+
+
+  this->weaponMan.addWeaponToSlot(0, 0, "RFCannon");
+  this->weaponMan.addWeaponToSlot(0, 1, "RFCannon");
+  this->weaponMan.addWeaponToSlot(0, 2, "RFCannon");
+  this->weaponMan.addWeaponToSlot(0, 3, "RFCannon");
+  this->weaponMan.addWeaponToSlot(1, 0, "RFCannon");
+  this->weaponMan.addWeaponToSlot(1, 1, "RFCannon");
+  this->weaponMan.addWeaponToSlot(1, 2, "RFCannon");
+  this->weaponMan.addWeaponToSlot(1, 3, "RFCannon");
+
+  this->weaponMan.addWeaponToSlot(0, 4, "NadionLaser");
+  this->weaponMan.addWeaponToSlot(0, 5, "NadionLaser");
+  this->weaponMan.addWeaponToSlot(2, 4, "NadionLaser");
+  this->weaponMan.addWeaponToSlot(2, 5, "NadionLaser");
+
+  this->weaponMan.addWeaponToSlot(0, 6, "Disruptor");
+  this->weaponMan.addWeaponToSlot(0, 7, "Disruptor");
+  this->weaponMan.addWeaponToSlot(3, 6, "Disruptor");
+  this->weaponMan.addWeaponToSlot(3, 7, "Disruptor");
+
+
+  this->secWeaponMan.createWeaponSlot(0, 1.5, 3, 0, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->secWeaponMan.createWeaponSlot(1, 2.6, 0, 3.0, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->secWeaponMan.createWeaponSlot(2, 1.5, 0, -.5, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->secWeaponMan.createWeaponSlot(3, 1.5, 0, .5, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->secWeaponMan.createWeaponSlot(4, 1.5, 0, .5, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->secWeaponMan.createWeaponSlot(5, 1.5, 0, -.5, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+
+  this->secWeaponMan.addWeaponToSlot(0, 2, "SwarmLauncher");
+
+
+  this->weaponMan.changeWeaponConfig(0);
   this->secWeaponMan.changeWeaponConfig(0);
 
 
-//   curWeaponPrimary    = 3;
-//   curWeaponSecondary  = 0;
-
   Playable::weaponConfigChanged();
 
-  reactorOutput     = 10;
-
-  weaponEnergyRegen = 10;       // 10 einheiten pro Sekunde
-  engineSpeedBase   = 15;
-  shieldRegen       = 2;
-
-  shieldEnergyShare = 0.3;
-  weaponEnergyShare = 0.3;
-  engineEnergyShare = 0.4;
-
-  shieldCur         = 100;
-  shieldMax         = 100;
-  shieldTH          = .2 * shieldMax;   // shield power must be 20% before shield kicks in again
-
-  this->setHealth( 100);
-  this->setHealthMax( 100);
-
-  electronicCur = 50;
-  electronicMax = 50;
-  electronicRegen   = 3;
-  electronicTH      = .7 * electronicMax; // 30% of eDamage can be handled by the ship
-
-
- this->loadModel("models/spaceships/human_spaceship_fighter.obj", .25);
+  this->bInit = false;
+
+  loadEnergyShare(.3,.3,.4);
+  loadShield(80, 100, .2, 2);
+  loadHealth(100, 100);
+  loadElectronic(40, 50, .7, 3.0);
+  loadReactor(10);
+  loadWeapon(10);
+  loadEngine(15);
+
+//   this->loadModel("models/spaceships/fighter_redesign9.obj");
   //this->setVisibiliy(false);
 
   bForward = bBackward = bLeft = bRight = bAscend = bDescend = bRollL = bRollR = bFire = bSecFire = false;
 
-  this->setHealthMax(shieldMax);
-  this->setHealth(shieldCur);
+//   this->setHealthMax(shieldMax);
+//   this->setHealth(shieldCur);
 
   this->travelNode = new PNode();
@@ -260,26 +235,7 @@
   this->cameraNode.addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
 
-  // widget handling
-  /*
-  this->electronicWidget = new OrxGui::GLGuiEnergyWidgetVertical();
-  this->electronicWidget->setDisplayedName(std::string(this->getClassName()) + " Electronics:");
-  this->electronicWidget->setSize2D(30,400);
-  this->electronicWidget->setAbsCoor2D(150,200);
-  this->electronicWidget->shiftDir2D(270);
-  this->updateElectronicWidget();
-  this->shieldWidget = new OrxGui::GLGuiEnergyWidgetVertical();
-  this->shieldWidget->setDisplayedName(std::string(this->getClassName()) + " Shield:");
-  this->shieldWidget->setSize2D(30,400);
-  this->shieldWidget->setAbsCoor2D(200,200);
-  this->shieldWidget->shiftDir2D(270);
-  this->updateShieldWidget();
-  if (this->hasPlayer())
-  {
-    State::getPlayer()->hud().setShiledWidget(this->shieldWidget);
-    State::getPlayer()->hud().setEnergyWidget(this->electronicWidget);
-  }
-  */
-  this->electronicWidget = NULL;
-  this->shieldWidget = NULL;
+
+//   this->electronicWidget = NULL;
+//   this->shieldWidget = NULL;
 
   //add events to the eventlist
@@ -298,51 +254,4 @@
   registerEvent(EV_MOUSE_MOTION);
 
-  this->weaponMan.setParentEntity( this);
-  this->secWeaponMan.setParentEntity( this);
-
-  this->weaponMan.setSlotCount(8);
-
-  this->weaponMan.setSlotPosition(0, Vector(0.0, 0, -3.0));
-  this->weaponMan.setSlotCapability(0, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-
-  this->weaponMan.setSlotPosition(1, Vector(0.0, 0, 3.0));
-  this->weaponMan.setSlotCapability(1, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-
-  this->weaponMan.setSlotPosition(2, Vector(1.0, 0, -1.5));
-  this->weaponMan.setSlotDirection(2, Quaternion(-M_PI_4*.5, Vector(1,0,0)));
-
-  this->weaponMan.setSlotPosition(3, Vector(1.0, 0, 1.5));
-  this->weaponMan.setSlotDirection(3, Quaternion(M_PI_4*.5, Vector(1,0,0)));
-
-  this->weaponMan.setSlotPosition(4, Vector(1.5, 0, .5));
-  this->weaponMan.setSlotDirection(4, Quaternion(-M_PI_4*.5+M_PI, Vector(1,0,0)));
-
-  this->weaponMan.setSlotPosition(5, Vector(1.5, 0, -.5));
-  this->weaponMan.setSlotDirection(5, Quaternion(+M_PI_4*.5-M_PI, Vector(1,0,0)));
-
-  this->weaponMan.setSlotPosition(6, Vector(0.5, 0, 2.5));
-  this->weaponMan.setSlotDirection(6, Quaternion(-M_PI_4*.5+M_PI, Vector(1,0,0)));
-
-  this->weaponMan.setSlotPosition(7, Vector(0.5, 0, -2.5));
-  this->weaponMan.setSlotDirection(7, Quaternion(+M_PI_4*.5-M_PI, Vector(1,0,0)));
-
-  this->secWeaponMan.setSlotPosition(0, Vector(1.5, 0, 0));
-  this->secWeaponMan.setSlotCapability(0, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-
-  this->secWeaponMan.setSlotPosition(1, Vector(2.6, 0, 3.0));
-  this->secWeaponMan.setSlotCapability(1, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-
-  this->secWeaponMan.setSlotPosition(2, Vector(1.5, 0, -.5));
-  this->secWeaponMan.setSlotDirection(2, Quaternion(-M_PI_4*.5, Vector(1,0,0)));
-
-  this->secWeaponMan.setSlotPosition(3, Vector(1.5, 0, .5));
-  this->secWeaponMan.setSlotDirection(3, Quaternion(M_PI_4*.5, Vector(1,0,0)));
-
-  this->secWeaponMan.setSlotPosition(4, Vector(1.5, 0, .5));
-  this->secWeaponMan.setSlotDirection(4, Quaternion(-M_PI_4*.5+M_PI, Vector(1,0,0)));
-
-  this->secWeaponMan.setSlotPosition(5, Vector(1.5, 0, -.5));
-  this->secWeaponMan.setSlotDirection(5, Quaternion(+M_PI_4*.5-M_PI, Vector(1,0,0)));
-
 
   this->weaponMan.getFixedTarget()->setParent(this);
@@ -384,26 +293,16 @@
   this->setSupportedPlaymodes(Playable::Horizontal | Playable::Vertical);
 
-  /// FIXME
-//   this->trail = new Trail( 5, 10, .2, this);
-//   this->trail->setTexture( "textures/engine.png");
-//
-//   this->trailL = new Trail( 5, 10, .2, this);
-//   this->trailL->setTexture( "textures/engine.png");
-//
-//   this->trailR = new Trail( 5, 10, .2, this);
-//   this->trailR->setTexture( "textures/engine.png");
-
 
   this->toList(OM_GROUP_00);
 
-  //FIXME Just testaddition to show the wobblegrid
-/*
-  this->test  = new Wobblegrid(5);
-  test->setTexture("textures/blub.png");
-
-  test->setAbsCoor( this->getAbsCoor() + Vector(0, 2, 0));
-  test->setParent( this);
-*/
-
+
+  dynamic_cast<WorldEntity*>(this)->createHealthWidget();
+  dynamic_cast<WorldEntity*>(this)->createShieldWidget();
+  dynamic_cast<WorldEntity*>(this)->createElectronicWidget();
+
+  if ( this->hasPlayer() ){
+    State::getPlayer()->hud().setShieldWidget(this->getShieldWidget());
+    State::getPlayer()->hud().setEnergyWidget(this->getElectronicWidget());
+  }
 }
 
@@ -415,4 +314,7 @@
 void SpaceShip::loadParams(const TiXmlElement* root)
 {
+  if(!root)
+    return;
+
   Playable::loadParams(root);
 
@@ -422,5 +324,37 @@
   LoadParam(root, "actionWidthPercentage", this, SpaceShip, setActionWidthPercentage);
 
-  State::getCamera()->setViewMode(Camera::ViewTop);
+  State::getCamera()->setViewMode(Camera::ViewNormal);
+  State::getCameraTargetNode()->setParent(this);
+  State::getCamera()->setParent(this);
+
+  LoadParam(root, "loadReactor", this, SpaceShip, loadReactor)
+  .describe("set reactor output");
+  LoadParam(root, "loadShield", this, WorldEntity, loadShield)
+  .describe("set shield parameters: current strenght , max strenght, threshhold value (0..1), regeneration rate");
+  LoadParam(root, "loadHealth", this, WorldEntity, loadHealth)
+  .describe("set armor/health parameters: current strenght , max strenght");
+  LoadParam(root, "loadElectronic", this, WorldEntity, loadElectronic)
+  .describe("set electronics parameters: current strenght , max strenght, threshhold value (0..1), regeneration rate");
+  LoadParam(root, "loadEngine", this, SpaceShip, loadEngine)
+  .describe("set base speed");
+  LoadParam(root, "loadEnergyShare", this, SpaceShip, loadEnergyShare)
+  .describe("set energy partitioning: shield, weapons, engine (sum should be 1)");
+  LoadParam(root, "loadWeapon", this, SpaceShip, loadWeapon)
+  .describe("set weapon regeneration");
+
+/*
+  LOAD_PARAM_START_CYCLE(root, element);
+  {
+    LoadParamXML_CYCLE(element, "weaponMan", this->weaponMan, WeaponManager, loadWeapons)
+    .describe("loads Weapons");
+  }
+  LOAD_PARAM_END_CYCLE(element);
+
+  LOAD_PARAM_START_CYCLE(root, element);
+  {
+    LoadParamXML_CYCLE(element, "secWeaponMan", this->secWeaponMan, WeaponManager, loadWeapons)
+    .describe("loads Weapons");
+  }
+  LOAD_PARAM_END_CYCLE(element);*/
 }
 
@@ -435,7 +369,7 @@
   bForward = bBackward = bLeft = bRight = bAscend = bDescend = bRollL = bRollR = bFire = bSecFire = false;
 
-  //xMouse = yMouse = 0;
-
-  this->setHealth(80);
+  this->resetHealth();
+  this->resetShield();
+  this->resetElectronic();
   this->velocity = Vector(0.0, 0.0, 0.0);
 }
@@ -448,8 +382,4 @@
   State::getPlayer()->hud().setRadarCenterNode(this->travelNode);
   State::getPlayer()->hud().setOverlayActive(true);
-  //dynamic_cast <OrxGui::GLGuiEnergyWidgetVertical*> (State::getPlayer()->hud().getArmorWidget())->setDisplayedName("Armor");
-  //dynamic_cast<Element2D*>(this->secWeaponMan.getFixedTarget())->setVisibility( true);
-  //this->attachCamera();
- // this->setPlaymode(Playable::Horizontal);
 }
 
@@ -461,6 +391,4 @@
   State::getCamera()->setEventHandling(true);
   State::getPlayer()->hud().setRadarCenterNode(NULL);
-  //dynamic_cast<Element2D*>(this->secWeaponMan.getFixedTarget())->setVisibility( false);
-  //this->detachCamera();
 }
 
@@ -473,6 +401,4 @@
   if(this->hasPlayer())
     Playable::postSpawn();
-
-  //setCollision(new CollisionCluster(1.0, Vector(0,0,0)));
 }
 
@@ -525,4 +451,25 @@
 void SpaceShip::tick (float time)
 {
+
+//   if( !this->bInit)
+//   {
+//     // now get slots from the mount points
+//     std::map<int, MountPoint*>::iterator it = this->mountPointMap.begin();
+//     for( ;it != this->mountPointMap.end(); it++)
+//     {
+//       WeaponSlot* ws = dynamic_cast<WeaponSlot*>((*it).second->getMount());
+//       if( ws != NULL && ws->isA(WeaponSlot::staticClassID()))
+//       {
+//         int slot = ws->getWeaponSlot();
+// //         int side = ws->getWeaponSide(); //FIXME / REMOVE: is not used// HACK needed for some weapons (left/right)
+//         this->getWeaponManager().setSlotPosition(slot, (*it).second->getCenter());
+//         this->getWeaponManager().setSlotDirection(slot, ws->getRelDir());
+// //         PRINTF(0)("setting slot %i\n", slot);
+// //         (*it).second->getCenter().debug();
+//       }
+//     }
+//   this->bInit = true;
+//   }
+
   // Playable::tick(time);
 
@@ -636,4 +583,5 @@
   if (!(State::getCamera()->getEventHandling()))
   {
+    //PRINTF(0)("\n\n\n\n\n\n\n\nSETCAMERA %x\n\n\n\n\n\n\n", State::getCamera());
     if( event.type == KeyMapper::PEV_VIEW0)
     {
@@ -750,65 +698,11 @@
   PRINTF(5)("ship hit for (%f,%f) \n",pDamage,eDamage);
 
-  if( this->shieldActive) {
-    if( this->shieldCur > pDamage) {
-      this->shieldCur = this->shieldCur - pDamage;
-    }
-    else { // shield <= pDamage
-      this->shieldCur -=pDamage;
-      this->shieldActive = false; //shield collapses
-      pDamage += this->shieldCur;
-      if( !this->shieldActive) {
-        this->armorCur -= pDamage / 2; // remaining damages hits armor at half rate
-        this->electronicCur -= eDamage;
-      }
-    }
-  }
-  else {
-    this->armorCur = this->armorCur - pDamage;
-    this->electronicCur = this->electronicCur - eDamage;
-  }
-  if( this->armorCur <= 0) { /* FIXME implement shipcrash*/ }
+  static float tmp = this->decreaseShield(pDamage);
+  if( tmp > 0)
+  if ( this->decreaseHealth(tmp / 2) > 0)
     this->destroy(this);
 
-  updateElectronicWidget();
-  updateShieldWidget();
-
-  this->setHealth( this->armorCur);
-}
-
-
-void SpaceShip::regen(float time){
-  float tmp;
-  if (this->armorCur != this->armorMax || this->armorRegen != 0){
-    tmp = this->armorCur + this->armorRegen * time;
-    if ( tmp > electronicMax)
-      this->armorCur = this->armorMax;
-    else
-      this->armorCur = tmp;
-  }
-  if (this->shieldCur != this->shieldMax || this->shieldRegen != 0){
-    tmp =  this->shieldCur + (this->shieldRegen + this->reactorOutput * this->shieldEnergyShare) * time;
-    if( tmp > shieldMax)
-      this->shieldCur = this->shieldMax;
-    else
-      this->shieldCur = tmp;
-    this->shieldActive = ( this->shieldActive || this->shieldCur > shieldTH);
-
-    updateShieldWidget();
-  }
-
-  this->setHealth( this->shieldCur);      // FIXME currently just to test share system
-
-  if (this->electronicCur != this->electronicMax || this->electronicRegen != 0){
-    tmp = this->electronicCur + this->electronicRegen * time;
-    if ( tmp > electronicMax)
-      this->electronicCur = this->electronicMax;
-    else
-      this->electronicCur = tmp;
-
-    updateElectronicWidget();
-  }
-
-}
+}
+
 
 
@@ -819,14 +713,23 @@
 void SpaceShip::weaponRegen(float time)
 {
-  float energy  = ( this->reactorOutput * this->weaponEnergyShare + this->weaponEnergyRegen) * time;
+  float energy = ( this->reactorOutput * this->weaponEnergyShare + this->weaponEnergyRegen) * time ;
   Weapon* weapon;
-  for( unsigned int i=0; i < this->weaponMan.getSlotCount(); i++)
-  {
+  int weaponCount = 0;
+  for( unsigned int i=0; i < this->weaponMan.getSlotCount(); i++) {
     weapon = this->weaponMan.getWeapon(i);
-    if( weapon != NULL && weapon->isActive())
-    {
+    if( weapon != NULL && weapon->isActive()) {
+      weaponCount++;
+    }
+  }
+
+  if (weaponCount == 0)
+    return;
+  energy *= ( this->weaponMan.getSlotCount() / (float)weaponCount );
+
+  for( unsigned int i=0; i < this->weaponMan.getSlotCount(); i++) {
+    weapon = this->weaponMan.getWeapon(i);
+    if( weapon != NULL && weapon->isActive()) {
       weapon->increaseEnergy( energy);
     }
-
   }
   // weaponMan.increaseAmmunition( weapon, energy);
@@ -834,6 +737,5 @@
 
 
-void SpaceShip::enterPlaymode(Playable::Playmode playmode)
-{
+void SpaceShip::enterPlaymode(Playable::Playmode playmode){
   switch(playmode)
   {
@@ -895,4 +797,45 @@
       }
       break;
+
+
+    case Playable::Vertical:
+    {
+        this->travelNode->setAbsCoor(this->getAbsCoor());
+        this->travelNode->updateNode(0.01f);
+
+        this->isTravelDistanceInit = false;
+
+        if(this->entityTrack)
+           this->travelNode->setParent(this->entityTrack->getTrackNode());
+
+        this->setParent(this->travelNode);
+        this->setRelCoor(0,0,0);
+
+        State::getCameraNode()->setParentSoft(this->travelNode);
+        //State::getCameraNode()->setParentSoft(this);
+        //State::getCameraNode()->setRelCoorSoft(-0.01, 40, 0);
+        State::getCameraTargetNode()->setParentSoft(this->travelNode);
+        //State::getCameraTargetNode()->setParentSoft(this);
+        //State::getCameraTargetNode()->setRelCoorSoft(0,0,0);
+        //this->setCameraMode(Camera::ViewNormal);
+        State::getCamera()->setEventHandling(false);
+
+        PRINTF(0)("\n\n\n\n\n\n\n\nSETCAMERA %x\n\n\n\n\n\n\n", State::getCamera());
+        State::getCamera()->setViewMode(Camera::ViewNormal);
+        State::getCameraTargetNode()->setParent(this);
+        State::getCamera()->setParent(this);
+
+
+        registerEvent(KeyMapper::PEV_VIEW0);
+        registerEvent(KeyMapper::PEV_VIEW1);
+        registerEvent(KeyMapper::PEV_VIEW2);
+        registerEvent(KeyMapper::PEV_VIEW3);
+        registerEvent(KeyMapper::PEV_VIEW4);
+        registerEvent(KeyMapper::PEV_VIEW5);
+
+        State::getCamera()->setParentMode(PNODE_ALL);
+
+      break;
+    }
 
     default:
@@ -1058,4 +1001,41 @@
     }
     case Playable::Vertical:
+    {
+      if ( !entityTrack || !entityTrack->getActionBox() )
+      {
+        break;
+      }
+      ActionBox * box = entityTrack->getActionBox();
+
+      this->travelVelocity = Vector(0, 0, 0);
+      float ssss = 50;
+      if ( this->bForward )
+      {
+        this->travelVelocity += Vector( 0, ssss, 0 );
+      }
+      if ( this->bBackward )
+      {
+        this->travelVelocity += Vector( 0, -ssss, 0 );
+      }
+      if ( this->bLeft )
+      {
+        this->travelVelocity += Vector( 0, 0, -ssss );
+      }
+      if ( this->bRight )
+      {
+        this->travelVelocity += Vector( 0, 0, ssss );
+      }
+
+      Vector ds = this->travelVelocity*dt;
+      Vector newPos = this->getRelCoor() + ds;
+      if ( newPos.y < -(box->getHeight_2()) || newPos.y > box->getHeight_2() )
+      {
+        this->travelVelocity.y = 0;
+      }
+      if ( newPos.z > box->getWidth_2() || newPos.z < -(box->getWidth_2()) )
+      {
+        this->travelVelocity.z = 0;
+      }
+    }
       break;
     default:
@@ -1099,43 +1079,44 @@
 }
 
-void SpaceShip::updateElectronicWidget()
-{
-  if (this->electronicWidget != NULL)
-  { //if it exists already: update it
-     this->electronicWidget->setMaximum(this->electronicMax);
-     this->electronicWidget->setValue(this->electronicCur);
-  }
-  else
-  { //create the widget
-    this->electronicWidget = new OrxGui::GLGuiEnergyWidgetVertical();
-    this->electronicWidget->getBarWidget()->setChangedValueColor(Color(1,0,0,1));
-    //this->electronicWidget->setDisplayedName("Electronics:");
-    //this->electronicWidget->setSize2D(100,20);
-    //this->electronicWidget->setAbsCoor2D(150,200);
-    this->updateElectronicWidget();
-    if (this->hasPlayer())
-      State::getPlayer()->hud().setEnergyWidget(this->electronicWidget);
-  }
-}
-
-void SpaceShip::updateShieldWidget()
-{
-  if (this->shieldWidget != NULL)
-  {
-    this->shieldWidget->setMaximum(this->shieldMax);
-    this->shieldWidget->setValue(this->shieldCur);;
-  }
-  else
-  {
-    this->shieldWidget = new OrxGui::GLGuiEnergyWidgetVertical();
-    this->shieldWidget->getBarWidget()->setChangedValueColor(Color(1,0,0,1));
-    //this->shieldWidget->setDisplayedName("Shield:");
-    //his->shieldWidget->setSize2D(100,20);
-    //this->shieldWidget->setAbsCoor2D(200,200);
-    this->updateShieldWidget();
-    if (this->hasPlayer())
-      State::getPlayer()->hud().setShiledWidget(this->shieldWidget);
-  }
-}
+// void SpaceShip::updateElectronicWidget()
+// {
+//   if (this->electronicWidget != NULL)
+//   { //if it exists already: update it
+//      this->electronicWidget->setMaximum(this->electronicMax);
+//      this->electronicWidget->setValue(this->electronicCur);
+//   }
+//   else
+//   { //create the widget
+//     this->electronicWidget = new OrxGui::GLGuiEnergyWidgetVertical();
+//     this->electronicWidget->getBarWidget()->setChangedValueColor(Color(1,0,0,1));
+//     //this->electronicWidget->setDisplayedName("Electronics:");
+//     //this->electronicWidget->setSize2D(100,20);
+//     //this->electronicWidget->setAbsCoor2D(150,200);
+//     this->updateElectronicWidget();
+//     if (this->hasPlayer())
+//       State::getPlayer()->hud().setEnergyWidget(this->electronicWidget);
+//   }
+// }
+// 
+// void SpaceShip::updateShieldWidget()
+// {
+//   if (this->shieldWidget != NULL)
+//   {
+//     this->shieldWidget->setMaximum(this->shieldMax);
+//     this->shieldWidget->setValue(this->shieldCur);;
+//   }
+//   else
+//   {
+//     this->shieldWidget = new OrxGui::GLGuiEnergyWidgetVertical();
+//     this->shieldWidget->getBarWidget()->setChangedValueColor(Color(1,0,0,1));
+//     //this->shieldWidget->setDisplayedName("Shield:");
+//     //his->shieldWidget->setSize2D(100,20);
+//     //this->shieldWidget->setAbsCoor2D(200,200);
+//     this->updateShieldWidget();
+//     if (this->hasPlayer())
+//       State::getPlayer()->hud().setShiledWidget(this->shieldWidget);
+//   }
+// }
+
 
 void SpaceShip::setCameraDistance(float dist)
@@ -1176,5 +1157,5 @@
 
   State::getPlayer()->hud().setOverlayPercentage(100-int(100*this->actionWidthPercentage));
-  PRINTF(0)("TravelDistance has been updated\n");
+//   PRINTF(0)("TravelDistance has been updated\n");
   this->isTravelDistanceInit = true;
 }
@@ -1189,2 +1170,4 @@
     this->isTravelDistanceInit = false;
 };
+
+
